import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
import java.awt.Color;

public class Level  extends World
{
    private ArrayList objs = new ArrayList();
    
    public final int WIDTH = 440;
    public final int HEIGHT = 340;
    
    public final int UP = 0;
    public final int RIGHT = 1;
    public final int DOWN = 2;
    public final int LEFT = 3;
    
    public int x = 0;
    public int y = 0;

    public Level() {    
        super(440, 340, 1);
        setPaintOrder(Blackout.class, Scrollable.class);
        GreenfootImage image = new GreenfootImage(20,20); 
        image.setColor(Color.BLACK); 
        image.fillRect(0,0,20,20);
        setBackground(image);
        
        super.addObject(new Player(), 219, 169);
        
        for(int i = 0; i < 22; i++) {
            for(int j = 0; j < 2; j++) {
                super.addObject(new Blackout(), 20 * i + 10, 10 + j*320);
            }
        }
        for(int i = 0; i < 15; i++) {
            for(int j = 0; j < 2; j++) {
                super.addObject(new Blackout(), 420 * j + 10, 30 + i*20);
            }
        }
        
        for(int i = 0; i < 20; i++) {
            for(int j = 0; j < 2; j++) {
                objs.add(new Block(20 * i + 30, 30 + j*280));
            }
        }
        for(int i = 0; i < 13; i++) {
            for(int j = 0; j < 2; j++) {
                objs.add(new Block(380 * j + 30, 50 + i*20));
            }
        }
        updateScreen();
    }    
    
    public void addObject(Scrollable s) {
        objs.add(s);
    }
    
    public void removeObject(Scrollable s) {
        objs.remove(s);
    }
    
    public void act() {
        
    }
        
    private void updateScreen() {
        for(int i = 0; i < objs.size(); i++) {
            Scrollable s = (Scrollable) objs.get(i);
            if(s.isInWorld()) {
                if(( s.getPX() <= x ) || ( s.getPX() > x + WIDTH) || (s.getPY() <= y) || ( s.getPY() >= y + HEIGHT)) {
                        super.removeObject( s );
                        s.setState(s.REMOVE);                    
                }
                else {
                    s.setLocation( s.getPX() - x, s.getPY() - y);
                }
            }
            else {
                if(( s.getPX() >= x ) && ( s.getPX() < x + WIDTH)) {
                    if(( s.getPY() >= y) && ( s.getPY() <= y + HEIGHT)) {
                        super.addObject( s , s.getPX() -x , s.getPY() -y);
                        s.setState(s.ADD);
                    }
                }
            }
        }
    }
    
    public void moveScreen(int direction) {
        switch(direction) {
            case UP: y -= 2; break;
            case RIGHT: x += 2; break;
            case DOWN: y += 2; break;
            case LEFT: x -= 2; break;
            default: System.err.println("Fehler bei: Level.moveScreen"); break;
        }
        updateScreen();
    }
    
}

